VTK: vtkGarbageCollector Class Reference

| VTK 9.3.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Friends | List of all members
vtkGarbageCollector Class Reference

Detect and break reference loops. More...

`#include <vtkGarbageCollector.h>`

Inheritance diagram for vtkGarbageCollector:
[legend]
Collaboration diagram for vtkGarbageCollector:
[legend]

## Public Types
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkGarbageCollector * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkTypeBool | IsTypeOf (const char *type)
static vtkGarbageCollector * | SafeDownCast (vtkObjectBase *o)
static vtkGarbageCollector * | New ()
static void | Collect ()
| Collect immediately using any objects whose collection was previously deferred as a root for the reference graph walk. More...
static void | Collect (vtkObjectBase *root)
| Collect immediately using the given object as the root for a reference graph walk. More...
static void | DeferredCollectionPush ()
| Push/Pop whether to do deferred collection. More...
static void | DeferredCollectionPop ()
| Push/Pop whether to do deferred collection. More...
static void | SetGlobalDebugFlag (bool flag)
| Set/Get global garbage collection debugging flag. More...
static bool | GetGlobalDebugFlag ()
| Set/Get global garbage collection debugging flag. More...
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkGarbageCollector ()
| ~vtkGarbageCollector () override
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Friends
class | vtkGarbageCollectorManager
class | vtkObjectBaseToGarbageCollectorFriendship
void VTKCOMMONCORE_EXPORT | vtkGarbageCollectorReportInternal (vtkGarbageCollector *, vtkObjectBase *, void *, const char *)

## Additional Inherited Members
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Detailed Description

Detect and break reference loops.

vtkGarbageCollector is used by VTK classes that may be involved in reference counting loops (such as Algorithm <-> Executive). It detects strongly connected components of the reference graph that have been leaked deletes them. The garbage collector uses the ReportReferences method to search the reference graph and construct a net reference count for each connected component. If the net reference count is zero the entire set of objects is deleted. Deleting each component may leak other components, which are then collected recursively.

To enable garbage collection for a class, add these members:

public:
bool UsesGarbageCollector() const override { return true; }
protected:
void ReportReferences(vtkGarbageCollector* collector) override
{
// Report references held by this object that may be in a loop.
this->Superclass::ReportReferences(collector);
vtkGarbageCollectorReport(collector, this->OtherObject, "Other Object");
}
vtkGarbageCollector
Detect and break reference loops.
Definition: vtkGarbageCollector.h:80
vtkObjectBase::UsesGarbageCollector
virtual bool UsesGarbageCollector() const
Indicate whether the class uses vtkGarbageCollector or not.
Definition: vtkObjectBase.h:222
vtkObjectBase::ReportReferences
virtual void ReportReferences(vtkGarbageCollector *)
vtkGarbageCollectorReport
void VTKCOMMONCORE_EXPORT vtkGarbageCollectorReport(vtkGarbageCollector *collector, vtkSmartPointerBase &ptr, const char *desc)
Function to report a reference held by a smart pointer to a collector.

The implementations should be in the .cxx file in practice. It is important that the reference be reported using the real pointer or smart pointer instance that holds the reference. When collecting the garbage collector will actually set this pointer to nullptr. The destructor of the class should be written to deal with this. It is also expected that an invariant is maintained for any reference that is reported. The variable holding the reference must always either be nullptr or refer to a fully constructed valid object. Therefore code like "this->Object->UnRegister(this)" must be avoided if "this->Object" is a reported reference because it is possible that the object is deleted before UnRegister returns but then "this->Object" will be left as a dangling pointer. Instead use code like

vtkObjectBase* obj = this->Object;
this->Object = 0;
obj->UnRegister(this);
vtkObjectBase
abstract base class for most VTK objects
Definition: vtkObjectBase.h:72
vtkObjectBase::UnRegister
virtual void UnRegister(vtkObjectBase *o)
Decrease the reference count (release by another object).

so that the reported reference maintains the invariant.

If subclassing from a class that already supports garbage collection, one need only provide the ReportReferences method.

Tests:
  vtkGarbageCollector (Tests)

Definition at line 79 of file vtkGarbageCollector.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkObject vtkGarbageCollector::Superclass

Definition at line 82 of file vtkGarbageCollector.h.

## Constructor & Destructor Documentation

## ◆ vtkGarbageCollector()

vtkGarbageCollector::vtkGarbageCollector | ( |  | ) |
| protected

## ◆ ~vtkGarbageCollector()

vtkGarbageCollector::~vtkGarbageCollector | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ IsTypeOf()

static vtkTypeBool vtkGarbageCollector::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkGarbageCollector::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkObjectBase.

## ◆ SafeDownCast()

static vtkGarbageCollector* vtkGarbageCollector::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkGarbageCollector::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

## ◆ NewInstance()

vtkGarbageCollector* vtkGarbageCollector::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkGarbageCollector::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkObjectBase.

## ◆ New()

static vtkGarbageCollector* vtkGarbageCollector::New | ( |  | ) |
| static

## ◆ Collect() [1/2]

static void vtkGarbageCollector::Collect | ( |  | ) |
| static

Collect immediately using any objects whose collection was previously deferred as a root for the reference graph walk.

Strongly connected components in the reference graph are identified. Those with a net reference count of zero are deleted. When a component is deleted it may remove references to other components that are not part of the same reference loop but are held by objects in the original component. These removed references are handled as any other and their corresponding checks may be deferred. This method keeps collecting until no deferred collection checks remain.

## ◆ Collect() [2/2]

static void vtkGarbageCollector::Collect | ( | vtkObjectBase * | root | ) |
| static

Collect immediately using the given object as the root for a reference graph walk.

Strongly connected components in the reference graph are identified. Those with a net reference count of zero are deleted. When a component is deleted it may remove references to other components that are not part of the same reference loop but are held by objects in the original component. These removed references are handled as any other and their corresponding checks may be deferred. This method does continue collecting in this case.

## ◆ DeferredCollectionPush()

static void vtkGarbageCollector::DeferredCollectionPush | ( |  | ) |
| static

Push/Pop whether to do deferred collection.

Whenever the total number of pushes exceeds the total number of pops collection will be deferred. Code can call the Collect method directly to force collection.

## ◆ DeferredCollectionPop()

static void vtkGarbageCollector::DeferredCollectionPop | ( |  | ) |
| static

Push/Pop whether to do deferred collection.

Whenever the total number of pushes exceeds the total number of pops collection will be deferred. Code can call the Collect method directly to force collection.

## ◆ SetGlobalDebugFlag()

static void vtkGarbageCollector::SetGlobalDebugFlag | ( | bool | flag | ) |
| static

Set/Get global garbage collection debugging flag.

When set to true, all garbage collection checks will produce debugging information.

## ◆ GetGlobalDebugFlag()

static bool vtkGarbageCollector::GetGlobalDebugFlag | ( |  | ) |
| static

Set/Get global garbage collection debugging flag.

When set to true, all garbage collection checks will produce debugging information.

## Friends And Related Function Documentation

## ◆ vtkGarbageCollectorManager

friend class vtkGarbageCollectorManager
| friend

Definition at line 164 of file vtkGarbageCollector.h.

## ◆ vtkObjectBaseToGarbageCollectorFriendship

friend class vtkObjectBaseToGarbageCollectorFriendship
| friend

Definition at line 165 of file vtkGarbageCollector.h.

## ◆ vtkGarbageCollectorReportInternal

void VTKCOMMONCORE_EXPORT vtkGarbageCollectorReportInternal | ( | vtkGarbageCollector * | ,
|  | vtkObjectBase * | ,
|  | void * | ,
|  | const char * |
| ) |  |
| friend

The documentation for this class was generated from the following file:

- Common/Core/vtkGarbageCollector.h